<!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8">
<title>documentation/info_segments/menu_.info</title>
<meta name="Generator" content="Vim/9.1">
<meta name="plugin-version" content="vim9.0_v2">
<meta name="syntax" content="none">
<meta name="settings" content="number_lines,use_css,no_foldcolumn,expand_tabs,line_ids,pre_wrap,prevent_copy=,use_input_for_pc=none">
<meta name="colorscheme" content="PaperColor">
<style>
<!--
pre { white-space: pre-wrap; font-family: monospace; color: #d0d0d0; background-color: #000000; }
body { font-family: monospace; color: #d0d0d0; background-color: #000000; }
* { font-size: 1em; }
.textRainbow_lv1_p0 { color: #ffffe0; }
.textRainbow_lv0_o0 { color: #add8e6; }
.textRainbow_lv0_p0 { color: #add8e6; }
.LineNr { color: #585858; }
-->
</style>

<script>
<!--

/* function to open any folds containing a jumped-to line before jumping to it */
function JumpToLine()
{
  var lineNum;
  lineNum = window.location.hash;
  lineNum = lineNum.substr(1); /* strip off '#' */

  if (lineNum.indexOf('L') == -1) {
    lineNum = 'L'+lineNum;
  }
  var lineElem = document.getElementById(lineNum);
  /* Always jump to new location even if the line was hidden inside a fold, or
   * we corrected the raw number to a line ID.
   */
  if (lineElem) {
    lineElem.scrollIntoView(true);
  }
  return true;
}
if ('onhashchange' in window) {
  window.onhashchange = JumpToLine;
}

-->
</script>
</head>
<body onload='JumpToLine();'>
<pre id='vimCodeElement'>
<span id="L1" class="LineNr">  1 </span>03/19/85  menu_
<span id="L2" class="LineNr">  2 </span>
<span id="L3" class="LineNr">  3 </span>
<span id="L4" class="LineNr">  4 </span>The menu_ subroutine provides menu display and selection services.  It
<span id="L5" class="LineNr">  5 </span>can display a menu in a window and get a selection from the user.  The
<span id="L6" class="LineNr">  6 </span>entries work with menu objects.  A menu object is a pointer to an
<span id="L7" class="LineNr">  7 </span>internal description of a menu.  The caller is expected to preserve the
<span id="L8" class="LineNr">  8 </span>pointer, and to perform no operation on it other than comparison with
<span id="L9" class="LineNr">  9 </span>the null pointer or with another menu object, except through the menu_
<span id="L10" class="LineNr"> 10 </span>subroutine.  Declarations for the entries and the associated structures
<span id="L11" class="LineNr"> 11 </span>are in the include file menu_dcls.incl.pl1.
<span id="L12" class="LineNr"> 12 </span>
<span id="L13" class="LineNr"> 13 </span>
<span id="L14" class="LineNr"> 14 </span>Entry points in menu_:
<span id="L15" class="LineNr"> 15 </span>   <span class="textRainbow_lv0_p0">(</span>List is generated by the help command<span class="textRainbow_lv0_p0">)</span>
<span id="L16" class="LineNr"> 16 </span>
<span id="L17" class="LineNr"> 17 </span>
<span id="L18" class="LineNr"> 18 </span>:Entry:  create:  03/19/85 menu_$create
<span id="L19" class="LineNr"> 19 </span>
<span id="L20" class="LineNr"> 20 </span>
<span id="L21" class="LineNr"> 21 </span>Function:  This entry creates a menu object given its description.  The
<span id="L22" class="LineNr"> 22 </span>menu data structure is allocated in a caller supplied area, and may be
<span id="L23" class="LineNr"> 23 </span>saved across processes by calling menu_$store.  A pointer to the new
<span id="L24" class="LineNr"> 24 </span>menu is returned, also with the minimum size of a window to hold the
<span id="L25" class="LineNr"> 25 </span>menu.
<span id="L26" class="LineNr"> 26 </span>
<span id="L27" class="LineNr"> 27 </span>
<span id="L28" class="LineNr"> 28 </span>Syntax:
<span id="L29" class="LineNr"> 29 </span>declare menu_$create entry <span class="textRainbow_lv0_p0">(</span><span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span> char <span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span> varying<span class="textRainbow_lv0_o0">,</span> <span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span> char <span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span> varying<span class="textRainbow_lv0_o0">,</span>
<span id="L30" class="LineNr"> 30 </span>     <span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span> char <span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span> varying<span class="textRainbow_lv0_o0">,</span> ptr<span class="textRainbow_lv0_o0">,</span> <span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span> char <span class="textRainbow_lv1_p0">(</span>1<span class="textRainbow_lv1_p0">)</span> unal<span class="textRainbow_lv0_o0">,</span> ptr<span class="textRainbow_lv0_o0">,</span> ptr<span class="textRainbow_lv0_o0">,</span> ptr<span class="textRainbow_lv0_o0">,</span>
<span id="L31" class="LineNr"> 31 </span>     fixed bin <span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L32" class="LineNr"> 32 </span>call menu_$create <span class="textRainbow_lv0_p0">(</span>choices<span class="textRainbow_lv0_o0">,</span> headers<span class="textRainbow_lv0_o0">,</span> trailers<span class="textRainbow_lv0_o0">,</span> format_ptr<span class="textRainbow_lv0_o0">,</span> keys<span class="textRainbow_lv0_o0">,</span>
<span id="L33" class="LineNr"> 33 </span>     area_ptr<span class="textRainbow_lv0_o0">,</span> needs_ptr<span class="textRainbow_lv0_o0">,</span> menu<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L34" class="LineNr"> 34 </span>
<span id="L35" class="LineNr"> 35 </span>
<span id="L36" class="LineNr"> 36 </span>Arguments:
<span id="L37" class="LineNr"> 37 </span>choices
<span id="L38" class="LineNr"> 38 </span>   is an array of the names of the options.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span> If the maximum
<span id="L39" class="LineNr"> 39 </span>   number of choices is exceeded, the code menu_et_$too_many_options is
<span id="L40" class="LineNr"> 40 </span>   returned.  The current maximum is 61.
<span id="L41" class="LineNr"> 41 </span>headers
<span id="L42" class="LineNr"> 42 </span>   is an array of headers.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span> If the length of the first header
<span id="L43" class="LineNr"> 43 </span>   is zero, then no headers are used.  This allows the caller to
<span id="L44" class="LineNr"> 44 </span>   specify no headers, without resorting to a zero-extent array, which
<span id="L45" class="LineNr"> 45 </span>   is invalid PL/I.
<span id="L46" class="LineNr"> 46 </span>trailers
<span id="L47" class="LineNr"> 47 </span>   is an array of trailers.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span> As for headers, a zero-length
<span id="L48" class="LineNr"> 48 </span>   first trailer means that no trailers are displayed.
<span id="L49" class="LineNr"> 49 </span>
<span id="L50" class="LineNr"> 50 </span>
<span id="L51" class="LineNr"> 51 </span>format_ptr
<span id="L52" class="LineNr"> 52 </span>   points to a structure, menu_format, that controls formatting of the
<span id="L53" class="LineNr"> 53 </span>   menu.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span> This structure is declared in menu_dcls.incl.pl1.
<span id="L54" class="LineNr"> 54 </span>keys
<span id="L55" class="LineNr"> 55 </span>   is an array specifying the keystroke for each option.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span> The
<span id="L56" class="LineNr"> 56 </span>   array must have at least as many elements as the array of option
<span id="L57" class="LineNr"> 57 </span>   names.  If not, the error code menu_et_$too_few_keys is returned.
<span id="L58" class="LineNr"> 58 </span>   It may have more keys than choices.  Each item of the array must be
<span id="L59" class="LineNr"> 59 </span>   unique, or menu_et_$keys_not_unique is returned.  If the valid keys
<span id="L60" class="LineNr"> 60 </span>   <span class="textRainbow_lv0_p0">(</span>the keys for which there are choices<span class="textRainbow_lv0_p0">)</span> are either all upper case or
<span id="L61" class="LineNr"> 61 </span>   all lower case, menu_$get_choice will treat upper and lower case
<span id="L62" class="LineNr"> 62 </span>   letters identically.
<span id="L63" class="LineNr"> 63 </span>
<span id="L64" class="LineNr"> 64 </span>
<span id="L65" class="LineNr"> 65 </span>area_ptr
<span id="L66" class="LineNr"> 66 </span>   is a pointer to an area where the menu description is allocated.
<span id="L67" class="LineNr"> 67 </span>   <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span> If the area is not large enough, the area condition is
<span id="L68" class="LineNr"> 68 </span>   signalled.  If this pointer is null, the system free area is used.
<span id="L69" class="LineNr"> 69 </span>needs_ptr
<span id="L70" class="LineNr"> 70 </span>   points to the menu_requirements structure giving requirements to
<span id="L71" class="LineNr"> 71 </span>   display the menu.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>  The caller supplies this structure and
<span id="L72" class="LineNr"> 72 </span>   fills in the version number menu_requirements_version_1, the
<span id="L73" class="LineNr"> 73 </span>   remaining members are output from this entry.
<span id="L74" class="LineNr"> 74 </span>menu
<span id="L75" class="LineNr"> 75 </span>   is a newly created menu object.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L76" class="LineNr"> 76 </span>code
<span id="L77" class="LineNr"> 77 </span>   is a standard system error code, or an error code from menu_et_.
<span id="L78" class="LineNr"> 78 </span>   <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L79" class="LineNr"> 79 </span>
<span id="L80" class="LineNr"> 80 </span>
<span id="L81" class="LineNr"> 81 </span>:Entry:  delete:  03/19/85 menu_$delete
<span id="L82" class="LineNr"> 82 </span>
<span id="L83" class="LineNr"> 83 </span>
<span id="L84" class="LineNr"> 84 </span>Function:  This entry deletes a menu object from a specified value
<span id="L85" class="LineNr"> 85 </span>segment.
<span id="L86" class="LineNr"> 86 </span>
<span id="L87" class="LineNr"> 87 </span>
<span id="L88" class="LineNr"> 88 </span>Syntax:
<span id="L89" class="LineNr"> 89 </span>declare menu_$delete entry <span class="textRainbow_lv0_p0">(</span>char <span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> char <span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> char <span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> fixed bin
<span id="L90" class="LineNr"> 90 </span>     <span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L91" class="LineNr"> 91 </span>call menu_$delete <span class="textRainbow_lv0_p0">(</span>dirname<span class="textRainbow_lv0_o0">,</span> entryname<span class="textRainbow_lv0_o0">,</span> menu_name<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L92" class="LineNr"> 92 </span>
<span id="L93" class="LineNr"> 93 </span>
<span id="L94" class="LineNr"> 94 </span>Arguments:
<span id="L95" class="LineNr"> 95 </span>dirname
<span id="L96" class="LineNr"> 96 </span>   is the pathname of the containing directory.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L97" class="LineNr"> 97 </span>entryname
<span id="L98" class="LineNr"> 98 </span>   is the entryname of the segment.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span> It must have the value
<span id="L99" class="LineNr"> 99 </span>   suffix.
<span id="L100" class="LineNr">100 </span>menu_name
<span id="L101" class="LineNr">101 </span>   is the name that was assigned to the menu when it was stored <span class="textRainbow_lv0_p0">(</span>see
<span id="L102" class="LineNr">102 </span>   the description of menu_$store<span class="textRainbow_lv0_p0">)</span>.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L103" class="LineNr">103 </span>code
<span id="L104" class="LineNr">104 </span>   is a standard system error code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L105" class="LineNr">105 </span>
<span id="L106" class="LineNr">106 </span>
<span id="L107" class="LineNr">107 </span>:Entry:  describe:  03/19/85 menu_$describe
<span id="L108" class="LineNr">108 </span>
<span id="L109" class="LineNr">109 </span>
<span id="L110" class="LineNr">110 </span>Function:  This entry fills in a caller-supplied data structure
<span id="L111" class="LineNr">111 </span>describing some of the aspects of a menu object.  The caller can use
<span id="L112" class="LineNr">112 </span>this to ensure a window is sufficiently large to hold a menu.
<span id="L113" class="LineNr">113 </span>
<span id="L114" class="LineNr">114 </span>
<span id="L115" class="LineNr">115 </span>Syntax:
<span id="L116" class="LineNr">116 </span>declare menu_$describe entry <span class="textRainbow_lv0_p0">(</span>ptr<span class="textRainbow_lv0_o0">,</span> ptr<span class="textRainbow_lv0_o0">,</span> fixed bin <span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L117" class="LineNr">117 </span>call menu_$describe <span class="textRainbow_lv0_p0">(</span>menu<span class="textRainbow_lv0_o0">,</span> needs_ptr<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L118" class="LineNr">118 </span>
<span id="L119" class="LineNr">119 </span>
<span id="L120" class="LineNr">120 </span>Arguments:
<span id="L121" class="LineNr">121 </span>menu
<span id="L122" class="LineNr">122 </span>   is the menu object to describe.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L123" class="LineNr">123 </span>needs_ptr
<span id="L124" class="LineNr">124 </span>   points to a structure declared like menu_requirements.
<span id="L125" class="LineNr">125 </span>  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span> The caller fills in the version to
<span id="L126" class="LineNr">126 </span>   be menu_requirements_version_1, and the remaining members are filled
<span id="L127" class="LineNr">127 </span>   in by this entry.
<span id="L128" class="LineNr">128 </span>code
<span id="L129" class="LineNr">129 </span>   is a standard system error code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L130" class="LineNr">130 </span>
<span id="L131" class="LineNr">131 </span>
<span id="L132" class="LineNr">132 </span>:Entry:  destroy:  03/19/85 menu_$destroy
<span id="L133" class="LineNr">133 </span>
<span id="L134" class="LineNr">134 </span>
<span id="L135" class="LineNr">135 </span>Function:  This entry is used to delete a menu object.  The caller uses
<span id="L136" class="LineNr">136 </span>this to free storage of a menu, since the representation of a menu is
<span id="L137" class="LineNr">137 </span>not known outside the menu_ subroutine.  This entry has no effect on
<span id="L138" class="LineNr">138 </span>screen contents or on stored menus.
<span id="L139" class="LineNr">139 </span>
<span id="L140" class="LineNr">140 </span>
<span id="L141" class="LineNr">141 </span>Syntax:
<span id="L142" class="LineNr">142 </span>declare menu_$destroy entry <span class="textRainbow_lv0_p0">(</span>ptr<span class="textRainbow_lv0_o0">,</span> fixed bin <span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L143" class="LineNr">143 </span>call menu_$destroy <span class="textRainbow_lv0_p0">(</span>menu<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L144" class="LineNr">144 </span>
<span id="L145" class="LineNr">145 </span>
<span id="L146" class="LineNr">146 </span>Arguments:
<span id="L147" class="LineNr">147 </span>menu
<span id="L148" class="LineNr">148 </span>   is the menu object to destroy.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L149" class="LineNr">149 </span>code
<span id="L150" class="LineNr">150 </span>   is a standard system error code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L151" class="LineNr">151 </span>
<span id="L152" class="LineNr">152 </span>
<span id="L153" class="LineNr">153 </span>:Entry:  display:  03/19/85 menu_$display
<span id="L154" class="LineNr">154 </span>
<span id="L155" class="LineNr">155 </span>
<span id="L156" class="LineNr">156 </span>Function:  This entry displays a menu object on a supplied window.
<span id="L157" class="LineNr">157 </span>
<span id="L158" class="LineNr">158 </span>
<span id="L159" class="LineNr">159 </span>Syntax:
<span id="L160" class="LineNr">160 </span>declare menu_$display entry <span class="textRainbow_lv0_p0">(</span>ptr<span class="textRainbow_lv0_o0">,</span> ptr<span class="textRainbow_lv0_o0">,</span> fixed bin <span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L161" class="LineNr">161 </span>call menu_$display <span class="textRainbow_lv0_p0">(</span>window<span class="textRainbow_lv0_o0">,</span> menu<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L162" class="LineNr">162 </span>
<span id="L163" class="LineNr">163 </span>
<span id="L164" class="LineNr">164 </span>Arguments:
<span id="L165" class="LineNr">165 </span>window
<span id="L166" class="LineNr">166 </span>   is a pointer to an IOCB for an I/O switch attached through
<span id="L167" class="LineNr">167 </span>   window_io_.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span> This window must be large enough to hold the
<span id="L168" class="LineNr">168 </span>   menu.  A menu window should be used ONLY for menu I/O, if redisplay
<span id="L169" class="LineNr">169 </span>   optimizations are desired.
<span id="L170" class="LineNr">170 </span>menu
<span id="L171" class="LineNr">171 </span>   is the menu object to be displayed.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L172" class="LineNr">172 </span>code
<span id="L173" class="LineNr">173 </span>   is a standard system error code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L174" class="LineNr">174 </span>
<span id="L175" class="LineNr">175 </span>
<span id="L176" class="LineNr">176 </span>:Entry:  get_choice:  03/19/85 menu_$get_choice
<span id="L177" class="LineNr">177 </span>
<span id="L178" class="LineNr">178 </span>
<span id="L179" class="LineNr">179 </span>Function:  This entry returns a choice from a menu.  The menu is
<span id="L180" class="LineNr">180 </span>assumed to be already displayed in the window.
<span id="L181" class="LineNr">181 </span>
<span id="L182" class="LineNr">182 </span>
<span id="L183" class="LineNr">183 </span>Syntax:
<span id="L184" class="LineNr">184 </span>declare menu_$get_choice entry <span class="textRainbow_lv0_p0">(</span>ptr<span class="textRainbow_lv0_o0">,</span> ptr<span class="textRainbow_lv0_o0">,</span> ptr<span class="textRainbow_lv0_o0">,</span> bit <span class="textRainbow_lv1_p0">(</span>1<span class="textRainbow_lv1_p0">)</span> aligned<span class="textRainbow_lv0_o0">,</span>
<span id="L185" class="LineNr">185 </span>     fixed bin<span class="textRainbow_lv0_o0">,</span> fixed bin <span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L186" class="LineNr">186 </span>call menu_$get_choice <span class="textRainbow_lv0_p0">(</span>window<span class="textRainbow_lv0_o0">,</span> menu<span class="textRainbow_lv0_o0">,</span> function_key_info<span class="textRainbow_lv0_o0">,</span> fkey<span class="textRainbow_lv0_o0">,</span>
<span id="L187" class="LineNr">187 </span>     selection<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L188" class="LineNr">188 </span>
<span id="L189" class="LineNr">189 </span>
<span id="L190" class="LineNr">190 </span>Arguments:
<span id="L191" class="LineNr">191 </span>window
<span id="L192" class="LineNr">192 </span>   is a pointer to the IOCB for the I/O switch used to display the
<span id="L193" class="LineNr">193 </span>   menu.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L194" class="LineNr">194 </span>menu
<span id="L195" class="LineNr">195 </span>   is the menu object on display in the window.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L196" class="LineNr">196 </span>function_key_info
<span id="L197" class="LineNr">197 </span>   is a pointer to a data structure describing the function keys
<span id="L198" class="LineNr">198 </span>   available on the terminal.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span> This data structure is obtained
<span id="L199" class="LineNr">199 </span>   by the caller from the ttt_info_$function_key_data subroutine.  If
<span id="L200" class="LineNr">200 </span>   this pointer is null, no function keys are used.
<span id="L201" class="LineNr">201 </span>
<span id="L202" class="LineNr">202 </span>
<span id="L203" class="LineNr">203 </span>fkey
<span id="L204" class="LineNr">204 </span>   returns a value of &quot;1&quot;b if a function key was hit instead of a menu
<span id="L205" class="LineNr">205 </span>   selection.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L206" class="LineNr">206 </span>selection
<span id="L207" class="LineNr">207 </span>   gives the option number or function key number chosen by the user.
<span id="L208" class="LineNr">208 </span>   For an option, it is a number between 1 and the highest defined
<span id="L209" class="LineNr">209 </span>   option, inclusive.  For a function key, it is the number of the
<span id="L210" class="LineNr">210 </span>   function key.
<span id="L211" class="LineNr">211 </span>code
<span id="L212" class="LineNr">212 </span>   is a standard system error code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L213" class="LineNr">213 </span>
<span id="L214" class="LineNr">214 </span>
<span id="L215" class="LineNr">215 </span>Notes:  If a terminal has no function keys, the caller can define input
<span id="L216" class="LineNr">216 </span>escape sequences for function keys.  These may be chosen to have
<span id="L217" class="LineNr">217 </span>mnemonic value to the end user.  For example, if Function Key 1 is used
<span id="L218" class="LineNr">218 </span>to print a help file, the input sequence ESC h could replace it.  In
<span id="L219" class="LineNr">219 </span>some applications, this will be easier for the end user to remember
<span id="L220" class="LineNr">220 </span>than an unlabelled function key.  The caller can define these keys by
<span id="L221" class="LineNr">221 </span>allocating and filling in the same function key structure normally
<span id="L222" class="LineNr">222 </span>returned by the ttt_info_ subroutine.
<span id="L223" class="LineNr">223 </span>
<span id="L224" class="LineNr">224 </span>If a key is hit that is not one of the option keys and is not a
<span id="L225" class="LineNr">225 </span>function key, then the terminal bell is rung.
<span id="L226" class="LineNr">226 </span>
<span id="L227" class="LineNr">227 </span>
<span id="L228" class="LineNr">228 </span>:Entry:  list:  03/19/85 menu_$list
<span id="L229" class="LineNr">229 </span>
<span id="L230" class="LineNr">230 </span>
<span id="L231" class="LineNr">231 </span>Function:  This entry lists the menu objects stored in a specified
<span id="L232" class="LineNr">232 </span>value segment.
<span id="L233" class="LineNr">233 </span>
<span id="L234" class="LineNr">234 </span>
<span id="L235" class="LineNr">235 </span>Syntax:
<span id="L236" class="LineNr">236 </span>declare menu_$list entry <span class="textRainbow_lv0_p0">(</span>char <span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> char <span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> char <span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> ptr<span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv0_o0">,</span>
<span id="L237" class="LineNr">237 </span>     ptr<span class="textRainbow_lv0_o0">,</span> fixed bin <span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L238" class="LineNr">238 </span>call menu_$list <span class="textRainbow_lv0_p0">(</span>dirname<span class="textRainbow_lv0_o0">,</span> entryname<span class="textRainbow_lv0_o0">,</span> menu_starname<span class="textRainbow_lv0_o0">,</span> area_ptr<span class="textRainbow_lv0_o0">,</span>
<span id="L239" class="LineNr">239 </span>     menu_list_info_version<span class="textRainbow_lv0_o0">,</span> menu_list_info_ptr<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L240" class="LineNr">240 </span>
<span id="L241" class="LineNr">241 </span>
<span id="L242" class="LineNr">242 </span>Arguments:
<span id="L243" class="LineNr">243 </span>dirname
<span id="L244" class="LineNr">244 </span>   is the pathname of the containing directory.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L245" class="LineNr">245 </span>entryname
<span id="L246" class="LineNr">246 </span>   is the entryname of the segment.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span> It must have the value
<span id="L247" class="LineNr">247 </span>   suffix.
<span id="L248" class="LineNr">248 </span>menu_starname
<span id="L249" class="LineNr">249 </span>   is matched against the names of the menus stored in the segment.
<span id="L250" class="LineNr">250 </span>   <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span> Only names that match menu_starname are returned.  <span class="textRainbow_lv0_p0">(</span>see the
<span id="L251" class="LineNr">251 </span>   description of menu_$store<span class="textRainbow_lv0_p0">)</span>.
<span id="L252" class="LineNr">252 </span>area_ptr
<span id="L253" class="LineNr">253 </span>   is a pointer to an area in which to allocate the structure
<span id="L254" class="LineNr">254 </span>   containing the menu names.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span> If it is null, the system free
<span id="L255" class="LineNr">255 </span>   area is used.
<span id="L256" class="LineNr">256 </span>
<span id="L257" class="LineNr">257 </span>
<span id="L258" class="LineNr">258 </span>menu_list_info_version
<span id="L259" class="LineNr">259 </span>   is the version of the menu_list_info structure that the caller
<span id="L260" class="LineNr">260 </span>   expects.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span> It must be a supported menu_list_info structure
<span id="L261" class="LineNr">261 </span>   version.  The only supported version is menu_list_info_version_1.
<span id="L262" class="LineNr">262 </span>menu_list_info_ptr
<span id="L263" class="LineNr">263 </span>   is a pointer to the menu_list_info structure, declared in
<span id="L264" class="LineNr">264 </span>   menu_dcls.incl.pl1.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L265" class="LineNr">265 </span>code
<span id="L266" class="LineNr">266 </span>   is a standard system error code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L267" class="LineNr">267 </span>
<span id="L268" class="LineNr">268 </span>
<span id="L269" class="LineNr">269 </span>:Entry:  retrieve:  03/19/85 menu_$retrieve
<span id="L270" class="LineNr">270 </span>
<span id="L271" class="LineNr">271 </span>
<span id="L272" class="LineNr">272 </span>Function:  This entry retrieves a menu from a specified segment.  The
<span id="L273" class="LineNr">273 </span>segment must be a value segment.  The menu data structure is allocated
<span id="L274" class="LineNr">274 </span>in a caller-supplied area.  The menu information is copied from the
<span id="L275" class="LineNr">275 </span>menu object stored in the segment into the newly allocated structure.
<span id="L276" class="LineNr">276 </span>
<span id="L277" class="LineNr">277 </span>
<span id="L278" class="LineNr">278 </span>Syntax:
<span id="L279" class="LineNr">279 </span>declare menu_$retrieve entry <span class="textRainbow_lv0_p0">(</span>char <span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> char <span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> char <span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> ptr<span class="textRainbow_lv0_o0">,</span> ptr<span class="textRainbow_lv0_o0">,</span>
<span id="L280" class="LineNr">280 </span>     fixed bin <span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L281" class="LineNr">281 </span>call menu_$retrieve <span class="textRainbow_lv0_p0">(</span>dirname<span class="textRainbow_lv0_o0">,</span> entryname<span class="textRainbow_lv0_o0">,</span> menu_name<span class="textRainbow_lv0_o0">,</span> area_ptr<span class="textRainbow_lv0_o0">,</span> menu_ptr<span class="textRainbow_lv0_o0">,</span>
<span id="L282" class="LineNr">282 </span>     code<span class="textRainbow_lv0_p0">)</span>;
<span id="L283" class="LineNr">283 </span>
<span id="L284" class="LineNr">284 </span>
<span id="L285" class="LineNr">285 </span>Arguments:
<span id="L286" class="LineNr">286 </span>dirname
<span id="L287" class="LineNr">287 </span>   is the pathname of the containing directory.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L288" class="LineNr">288 </span>entryname
<span id="L289" class="LineNr">289 </span>   is the entryname of the segment.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span> It must have the value
<span id="L290" class="LineNr">290 </span>   suffix.
<span id="L291" class="LineNr">291 </span>menu_name
<span id="L292" class="LineNr">292 </span>   is the name that was assigned to the menu when it was stored <span class="textRainbow_lv0_p0">(</span>see
<span id="L293" class="LineNr">293 </span>   the description of menu_$store<span class="textRainbow_lv0_p0">)</span>.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L294" class="LineNr">294 </span>area_ptr
<span id="L295" class="LineNr">295 </span>   is a pointer to an area where the menu object is allocated.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L296" class="LineNr">296 </span>   If this argument is null, the system free area is used.  If the area
<span id="L297" class="LineNr">297 </span>   is not large enough, the area condition is signalled.
<span id="L298" class="LineNr">298 </span>
<span id="L299" class="LineNr">299 </span>
<span id="L300" class="LineNr">300 </span>menu_ptr
<span id="L301" class="LineNr">301 </span>   is a pointer to the menu object that is retrieved from the segment.
<span id="L302" class="LineNr">302 </span>   <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L303" class="LineNr">303 </span>code
<span id="L304" class="LineNr">304 </span>   is a standard system error code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L305" class="LineNr">305 </span>
<span id="L306" class="LineNr">306 </span>
<span id="L307" class="LineNr">307 </span>:Entry:  store:  03/19/85 menu_$store
<span id="L308" class="LineNr">308 </span>
<span id="L309" class="LineNr">309 </span>
<span id="L310" class="LineNr">310 </span>Function:  This entry stores a menu object in a specified segment.  The
<span id="L311" class="LineNr">311 </span>specified segment must be a value segment.
<span id="L312" class="LineNr">312 </span>
<span id="L313" class="LineNr">313 </span>
<span id="L314" class="LineNr">314 </span>Syntax:
<span id="L315" class="LineNr">315 </span>declare menu_$store entry <span class="textRainbow_lv0_p0">(</span>char <span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> char <span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> char <span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> bit<span class="textRainbow_lv1_p0">(</span>1<span class="textRainbow_lv1_p0">)</span>
<span id="L316" class="LineNr">316 </span>     aligned<span class="textRainbow_lv0_o0">,</span> ptr<span class="textRainbow_lv0_o0">,</span> fixed bin <span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L317" class="LineNr">317 </span>call menu_$store <span class="textRainbow_lv0_p0">(</span>dirname<span class="textRainbow_lv0_o0">,</span> entryname<span class="textRainbow_lv0_o0">,</span> menu_name<span class="textRainbow_lv0_o0">,</span> create_sw<span class="textRainbow_lv0_o0">,</span> menu_ptr<span class="textRainbow_lv0_o0">,</span>
<span id="L318" class="LineNr">318 </span>     code<span class="textRainbow_lv0_p0">)</span>;
<span id="L319" class="LineNr">319 </span>
<span id="L320" class="LineNr">320 </span>
<span id="L321" class="LineNr">321 </span>Arguments:
<span id="L322" class="LineNr">322 </span>dirname
<span id="L323" class="LineNr">323 </span>   is the pathname of the containing directory.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L324" class="LineNr">324 </span>entryname
<span id="L325" class="LineNr">325 </span>   is the entryname of the segment.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span> It must have the value
<span id="L326" class="LineNr">326 </span>   suffix.
<span id="L327" class="LineNr">327 </span>menu_name
<span id="L328" class="LineNr">328 </span>   is a name to be assigned to the menu.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L329" class="LineNr">329 </span>create_sw
<span id="L330" class="LineNr">330 </span>   determines whether or not the segment is created if it does not
<span id="L331" class="LineNr">331 </span>   already exist.  If the segment does not exist, a value of &quot;1&quot;b will
<span id="L332" class="LineNr">332 </span>   cause it to be created.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L333" class="LineNr">333 </span>menu_ptr
<span id="L334" class="LineNr">334 </span>   is a pointer to the menu object that is to be stored in the segment.
<span id="L335" class="LineNr">335 </span>   <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L336" class="LineNr">336 </span>code
<span id="L337" class="LineNr">337 </span>   is a standard system error code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
</pre>
<script defer src='https://static.cloudflareinsights.com/beacon.min.js' data-cf-beacon='{"token": "4b6a131644014aa29fd88953508c3a3d"}'></script></body>
</html>
<!-- vim: set foldmethod=manual : -->
